team join Lurker @e[tag=prevent_despawn]
effect give @e[tag=prevent_despawn] invisibility infinite 255 true
tag @e[tag=aj.cave_lurker.root] add lurker.teleported
execute as @e[tag=prevent_despawn] at @s rotated as @s run function lurker:teleport

execute as @e[tag=lurker,type=minecraft:vindicator] at @s if entity @a[distance=0..30] run function lurker:lurker_anims

execute as @e[tag=fleeing_lurker,type=minecraft:ocelot] at @s if entity @a[distance=0..30] run function lurker:fleeing_lurker_anims

execute as @e[tag=stalking_lurker,type=minecraft:creaking] at @s if entity @a[distance=0..30] run function lurker:stalking_lurker_anims

execute as @e[tag=lurker,tag=!stunned] store result score @s HP run data get entity @s Health
execute as @e[tag=lurker,tag=!stunned] if score @s HP matches ..32 run function lurker:stun

execute as @e[tag=aj.cave_lurker.root,scores={deletion_timer=50..}] at @s unless entity @e[tag=prevent_despawn,distance=..5] as @s run function animated_java:cave_lurker/remove/this
execute as @e[tag=aj.cave_lurker.root] unless entity @e[tag=prevent_despawn,distance=..5] as @s run scoreboard players add @s deletion_timer 1

execute as @e[tag=prevent_despawn] anchored eyes run function lurker:raycast

scoreboard players add @e[tag=prevent_despawn] lurkerAmbient 1
scoreboard players set @e[tag=prevent_despawn,scores={lurkerAmbient=200}] lurkerAmbient 0
execute as @e[tag=prevent_despawn,scores={lurkerAmbient=50}] positioned as @s run playsound entity.ravager.ambient hostile @a ~ ~ ~ 0.6 0.5 0
execute as @e[tag=prevent_despawn,scores={lurkerAmbient=50}] positioned as @s run playsound entity.warden.angry hostile @a ~ ~ ~ 0.3 0.3 0
execute as @e[tag=prevent_despawn,scores={lurkerAmbient=50}] positioned as @s run playsound entity.husk.ambient hostile @a ~ ~ ~ 0.3 0.3 0

scoreboard players add @e[tag=prevent_despawn] lurkerMoving 1
scoreboard players set @e[tag=lurker,scores={lurkerMoving=8}] lurkerMoving 0
scoreboard players set @e[tag=prevent_despawn,nbt={Motion:[0.0,0.0,0.0]}] lurkerMoving 0
execute as @e[tag=lurker,scores={lurkerMoving=6}] positioned as @s run playsound entity.iron_golem.step hostile @a ~ ~ ~ 0.75 0.5 0
execute as @e[tag=lurker,scores={lurkerMoving=6}] positioned as @s run playsound entity.warden.step hostile @a ~ ~ ~ 1.0 0.5 0

scoreboard players set @e[tag=fleeing_lurker,scores={lurkerMoving=6}] lurkerMoving 0
execute as @e[tag=fleeing_lurker,scores={lurkerMoving=4}] positioned as @s run playsound entity.iron_golem.step hostile @a ~ ~ ~ 0.75 0.5 0
execute as @e[tag=fleeing_lurker,scores={lurkerMoving=4}] positioned as @s run playsound entity.warden.step hostile @a ~ ~ ~ 1.0 0.5 0

scoreboard players add @e[name="Cave Lurker",tag=lurker,tag=!aggro] aggro_timer 1
execute as @e[name="Cave Lurker",tag=lurker,scores={aggro_timer=600},tag=!aggro] if predicate lurker:30 run function lurker:get_aggro
execute as @e[name="Cave Lurker",tag=lurker,scores={aggro_timer=800},tag=!aggro] run tag @s add aggro

scoreboard players add @e[name="Cave Lurker",tag=lurker,tag=aggro] despawn_timer 1
execute as @e[name="Cave Lurker",tag=lurker,scores={despawn_timer=1200..},tag=aggro] run function lurker:despawn

scoreboard players add @e[name="Cave Lurker",tag=stalking_lurker] despawn_timer 1
execute as @e[name="Cave Lurker",tag=stalking_lurker,scores={despawn_timer=1200}] run function lurker:despawn
scoreboard players set @e[name="Cave Lurker",tag=stalking_lurker,scores={despawn_timer=1205}] despawn_timer 0

scoreboard players add @e[name="Cave Lurker",tag=fleeing_lurker] despawn_timer 1
execute as @e[name="Cave Lurker",tag=fleeing_lurker,scores={despawn_timer=800}] if predicate lurker:30 run function lurker:despawn
scoreboard players set @e[name="Cave Lurker",tag=fleeing_lurker,scores={despawn_timer=805}] despawn_timer 0

execute as @e[tag=stalking_lurker] positioned as @s if entity @e[type=minecraft:player,gamemode=!creative,gamemode=!spectator,distance=..5] run function lurker:too_close

execute as @e[tag=prevent_despawn] positioned as @s unless entity @e[tag=aj.cave_lurker.root,distance=..5] run function animated_java:cave_lurker/summon

execute as @e[tag=prevent_despawn] positioned as @s if entity @e[type=#boat,distance=..3] run scoreboard players add @s trapped_timer 1
execute as @e[tag=prevent_despawn,scores={trapped_timer=60..}] positioned as @s if entity @e[type=#boat,distance=..3] run function lurker:destroy_boat
execute as @e[tag=prevent_despawn,scores={trapped_timer=150..}] run scoreboard players set @s trapped_timer 0

clear @a knowledge_book

execute if entity @e[type=player,predicate=lurker:necklace_equipped] run function lurker:manage_necklace
execute if entity @e[type=player,scores={lurker.necklace.wearing=1}] run function lurker:manage_necklace

execute as @a[predicate=!lurker:necklace_wearing] run clear @s string[custom_model_data=696974]
execute as @a[predicate=lurker:necklace_wearing] positioned as @s if block ~ ~-1 ~ #lurker:natural_stones run function lurker:give_haste

schedule function lurker:hub 1t